#
#
# class Config(object):
#     num_layers = 2  # LSTM层数
#     data_path = 'data/'  # 诗歌的文本文件存放路径
#     pickle_path = 'tang.npz'  # 预处理好的二进制文件
#     author = None  # 只学习某位作者的诗歌
#     constrain = None  # 长度限制
#     category = 'poet.tang'  # 类别，唐诗还是宋诗歌(poet.song)
#     lr = 5e-4
#     weight_decay = 5e-4
#     use_gpu = True
#     epoch = 50
#     batch_size = 64
#     maxlen = 125  # 超过这个长度的之后字被丢弃，小于这个长度的在前面补空格
#     plot_every = 200  # 每200个batch 可视化一次
#     # use_env = True # 是否使用visodm
#     env = 'poetry'  # visdom env
#     max_gen_len = 200  # 生成诗歌最长长度
#     debug_file = '/tmp/debugp'
#     model_path = "./checkpoints/tang_36.pth"  # 预训练模型路径
#     prefix_words = '仙路尽头谁为峰？一见无始道成空。'  # 不是诗歌的组成部分，用来控制生成诗歌的意境
#     start_words = '闲云潭影日悠悠'  # 诗歌开始
#     acrostic = False  # 是否是藏头诗
#     model_prefix = 'checkpoints/tang'  # 模型保存路径
#     embedding_dim = 512
#     hidden_dim = 1024
#     mpo=False


import argparse
import torch
import os

parser = argparse.ArgumentParser()
group = parser.add_argument_group('parameters')
group.add_argument( '--net', type=str, default='mpo', choices=['mpo','mpo2','mpo3','operator','operator2'], help='network type')
group.add_argument( '--num_layers', type=int, default=2, help='num_layers of rnn')
group.add_argument( '--data_path', type=str, default='data/', help='data_path of poet')
group.add_argument( '--pickle_path', type=str, default='tang.npz', help='pickle_path')
group.add_argument( '--category', type=str, default='poet.tang', help='category of poet')
group.add_argument( '--lr', type=float, default=5e-4, help='learning rate')
group.add_argument( '--weight_decay', type=float, default=1e-4, help='weight_decay')
#group.add_argument( '--ingpu', action='store_false', help='store everything in GPU')
group.add_argument( '--cuda', type=int, default=0, help='ID of GPU to use, -1 for disabled')
group.add_argument( '--epoch', type=int, default=50, help='maximum number of steps')
group.add_argument( '--batch_size', type=int, default=64, help='number of samples')
group.add_argument( '--vocab_size', type=int, default=8400, help='vocab_size')
group.add_argument( '--maxlen', type=int, default=125, help='maximum number of word in one sample')
group.add_argument( '--plot_every', type=int, default=200, help='plot every x')
group.add_argument( '--env', type=str, default='poetry', help='visdom env')
group.add_argument( '--max_gen_len', type=int, default=200, help='maximum generation length of poet')
group.add_argument( '--debug_file', type=str, default='/tmp/debugp', help='debug_file')
group.add_argument( '--model_path', type=str, default="./checkpoints/tang_False_1.pth", help='model_path')
group.add_argument( '--prefix_words', type=str, default='仙路尽头谁为峰？一见无始道成空。', help='prefix_words')
group.add_argument( '--start_words', type=str, default='闲云潭影日悠悠', help='start_words')
group.add_argument( '--acrostic', action='store_true', help='acrostic')
group.add_argument( '--model_prefix', type=str, default='checkpoints/tang', help='model_prefix')
group.add_argument( '--embedding_dim', type=int, default=512, help='embedding_dim')
group.add_argument( '--hidden_dim', type=int, default=1024, help='hidden_dim')
group.add_argument( '--mpo', action='store_true', help='mpo')
group.add_argument( '--chi', type=int, default=4, help='Rank in the lr or mpo representations')
group.add_argument( '--chi2', type=int, default=4, help='Rank in the lr or mpo representations')
group.add_argument( '--dims', type=str, default="8,4,4,8;12,10,7,10", help='dtype')
group.add_argument( '--mpo3layers', type=int, default=2, help='num of mpo3 layers')
group.add_argument( '--bias', action='store_true', help='use bias')
group.add_argument( '--dtype', type=str, default='float32', choices=['float32', 'float64'], help='dtype')
#group.add_argument( '--cpu', action='store_true', help='use batch_norm_1d')
group.add_argument( '--num_train',type=int,default=500)
group.add_argument('--num_samples',type=int,default=1,help='synthetic samples, random pattern')
group.add_argument('--len_seq',type=int,default=11)
group.add_argument('--V',type=int,default=20,help='vocabulary size by generating')
group.add_argument('--N',type=int,default=2,help='layers of transformer')
group.add_argument('--d_model',type=int,default=256,help='model dimension for transformer')
group.add_argument('--d_ff',type=int,default=1024,help='dimesion of feed forward of transformer ')
group.add_argument('--h',type=int,default=1,help='number of multi head')
group.add_argument('--model_type',type=str,default='gru')
group.add_argument('--seed1',type=int,default=1)
group.add_argument('--seed2',type=int,default=1)
group.add_argument('--data_type',type=str,default='random_pattern')
group.add_argument('--optimizer',type=str,default='sgd')
group.add_argument('--test',action='store_true')
args = parser.parse_args()
'''
if args.ingpu >= 0:
    os.environ['CUDA_VISIBLE_DEVICES'] = str(args.cuda)
    args.use_cuda=True
    args.device = torch.device('cuda:0')
else:
    args.use_cuda=False
    args.device = torch.device('cpu')
'''
args.device = torch.device("cpu" if args.cuda < 0 else "cuda:" + str(args.cuda))
if args.dtype == 'float32':
    args.dtype = torch.float32
elif args.dtype == 'float64':
    args.dtype = torch.float64
else:
    raise ValueError('Unknown dtype: {}'.format(args.dtype))
'''
if args.cpu:
    args.use_cuda=False
    args.device = torch.device('cpu')
'''
#print("args.device=",args.device)



