import torch as t
import numpy as np
from torch.utils.data import DataLoader
from torch import optim
from torch import nn
from model import *
#from torchnet import meter
#import tqdm
from config import args
from test import *
import sys
import time

def train():
    
    device = args.device
    print(args.device)
    datas = np.load("tang.npz",allow_pickle=True)
    print(datas)
    data = datas['data']
    print(data)
    #print(ix2word[data[1]])
    print(data.shape[0])
    print(np.max(data))
    ix2word = datas['ix2word'].item()
    #print(ix2word)
    word2ix = datas['word2ix'].item()
    #print(word2ix)
    print(ix2word[data[1][0]])
    data = t.from_numpy(data)[:args.num_train]
    dataloader = DataLoader(data,
                            batch_size=args.batch_size,
                            shuffle=True,
                            num_workers=2)

   
    # model = PoetryModel(args, vocab_size=8400,
    #                     embedding_dim=args.embedding_dim,
    #                     hidden_dim = args.hidden_dim,mpo=args.mpo)
    model = PoetryModel(args)
    Configimizer = optim.Adam(model.parameters(),lr=args.lr)
    criterion = nn.CrossEntropyLoss()
    
    if args.model_path:
        model.load_state_dict(t.load(args.model_path,map_location='cpu'))
    
    model.to(device)
    #loss_meter = meter.AverageValueMeter()
    #f = open('result.txt','w')
    #sys.exit(0)
    for epoch in range(args.epoch):
        time0=time.time()
        #loss_meter.reset()
        total_loss=0.0
        all_samples=0
        #for li,data_ in tqdm.tqdm(enumerate(dataloader)):
        for li, data_ in (enumerate(dataloader)):
            #print(data_.shape)
            now_samples=data_.size(0)
            all_samples+=now_samples
            data_ = data_.long().transpose(1,0).contiguous()
            
            data_ = data_.to(device)
            #print(data_.shape)
            Configimizer.zero_grad()
            input_,target = data_[:-1,:],data_[1:,:]
            output,_ = model(input_)
            #print(output)
            #print(target)
            #print("Here",output.shape)
            #print(target.shape)
            
            # 这里要view(-1)
            loss = criterion(output,target.view(-1))
            loss.backward()
            Configimizer.step()
            total_loss+=loss.item()*now_samples
            #loss_meter.add(loss.item())
            # 进行可视化
            '''
            if (1+li)%args.plot_every == 0:
                print("训练损失为%s"%(str(loss_meter.mean)))
                f.write("训练损失为%s"%(str(loss_meter.mean)))
                for word in list(u"春江花月夜"):
                    gen_poetry = ''.join(generate(model,word,ix2word,word2ix))
                    print(gen_poetry)
                    f.write(gen_poetry)
                    f.write("\n\n\n")
                    f.flush()
            '''
        #print("训练损失为%s"%(str(loss_meter.mean)))
        print(all_samples)
        print(' average loss: ',  total_loss/all_samples)
        t.save(model.state_dict(),'%s_%s_%s.pth'%(args.model_prefix,args.mpo,epoch))
        print('used time: ', time.time()-time0)

if __name__ == '__main__':
    train()





