from Transformer import *
from torch.utils.data import DataLoader
class only_Encoder(nn.Module):
    def __init__(self,encoder,src_embed,generator):
        super(only_Encoder,self).__init__()
        self.encoder=encoder
        self.src_embed=src_embed
        self.generator=generator
    def forward(self,src,src_mask):
        return self.generator(self.encode(src,src_mask))
    def encode(self,src,src_mask):
        return self.encoder(self.src_embed(src),src_mask)
def make_model(src_vocab,N=6,d_model=256,d_ff=1024,h=1,dropout=0.1):
    c=copy.deepcopy
    attn=MultiHeadAttention(h,d_model)
    ff=PositionwiseFeedForward(d_model,d_ff,dropout)
    position=PositionalEncoding(d_model,dropout)
    model=only_Encoder(
        Encoder(EncoderLayer(d_model,c(attn),c(ff),dropout),N),
        nn.Sequential(Embeddings(d_model,src_vocab),c(position)),
        Generator(d_model,src_vocab))
    '''
    for p in model.parameters():
        if p.dim()>1:
           nn.init.xavier_uniform_(p)
    '''
    #print(model.src_embed[0].lut.weight)
    initrange = 0.01
    model.src_embed[0].lut.weight.data.uniform_(-initrange, initrange)
    model.generator.proj.bias.data.zero_()
    model.generator.proj.weight.data.uniform_(-initrange, initrange)
    return model
